
/********************************** (C) COPYRIGHT ******************************
* File Name          : CH559_IAP.C
* Author             : WCH
* Version            : V1.3
* Date               : 2016/06/24
* Description        : IAP ʾӳ
*                      1ִ֧أںΪ0Ϊ57600ڲڲ񣬾ӴۼӺͣۼӺʹط
*                      2֧USBأUSBΪȫ豸
                       3֧EEPROM
                       4֧оƬͺж
*******************************************************************************/

#include <stdlib.h>
#include <string.h>
#include <intrins.h>
#include "../../CH559.H"
#include "CH559_IAP.H"


sbit DisableIAP            = P1^0;                     //û
#define IAP_CODE_ADDR        (0xE800)             //1kΪ55XFlashһٲ1K
#define THIS_ENDP0_SIZE         DEFAULT_ENDP0_SIZE     //Ĭ϶˵0ĴС

// 豸
UINT8C    MyDevDescr[] = { 0x12, 0x01, 0x10, 0x01,
                           0xFF, 0x80, 0x55, THIS_ENDP0_SIZE,
                           0x48, 0x43, 0xe0, 0x55,
                           0x00, 0x01, 0x00, 0x00,0x00, 0x01
                         };
// 
UINT8C    MyCfgDescr[] = { 0x09, 0x02, 0x20, 0x00, 0x01, 0x01, 0x00, 0x80, 0x32,
                           0x09, 0x04, 0x00, 0x00, 0x02, 0xFF, 0x80, 0x55, 0x00,
                           0x07, 0x05, 0x82, 0x02, 0x40, 0x00, 0x00,
                           0x07, 0x05, 0x02, 0x02, 0x40, 0x00, 0x00
                         };
UINT8    UsbConfig = 0;                                // USBñ־
UINT8X    Ep0Buffer[THIS_ENDP0_SIZE] _at_ 0x0000 ;     // OUT&IN, must even address
UINT8X    Ep2Buffer[2*MAX_PACKET_SIZE] _at_ 0x0008 ;   // OUT+IN, must even address
#define   UsbSetupBuf     ((PUSB_SETUP_REQ)Ep0Buffer)

iap_cmd1 xdata iap_cmd  _at_ 0x0088;                   //IAP
UINT8   uart_bit;                                      //طʽȫֱ־λ1ʾΪڣ2ʾΪUSB
UINT16  chip_id,eeprom_len;
PUINT8C    pCode;

#pragma NOAREGS

/*******************************************************************************
* Function Name  : EraseBlock
* Description    : оƬĬϲһΪ1KB
* Input          : Addr    оƬַ1KBΪλ
* Output         : None
* Return         :         оƬ״̬
                    0x00   ɹ
                    0x01   ʱ
                    0x02   δ֪󣬲ʧ
*******************************************************************************/
UINT8    EraseBlock( UINT16 Addr )
{
	ROM_ADDR = Addr;
	if ( ROM_STATUS & bROM_ADDR_OK ) {                                          // ַЧ
		ROM_CTRL = ROM_CMD_ERASE;
		return( ( ROM_STATUS ^ bROM_ADDR_OK ) & 0x7F );                           // ״̬,0x00=success, 0x01=time out(bROM_CMD_TOUT), 0x02=unknown command(bROM_CMD_ERR)
	}
	else return( 0x40 );
}
/*******************************************************************************
* Function Name  : ProgWord
* Description    : оƬ̺
* Input          : Addr    оƬ̵ַַַΪżַ
                   Data    ݣWORDΪ׼
* Output         : None
* Return         :         оƬ̷״̬
                    0x00   ̳ɹ
                    0x01   ̳ʱ
                    0x02   δ֪󣬱ʧ
*******************************************************************************/
UINT8 ProgWord( UINT16 Addr, UINT16 Data )
{
	ROM_ADDR = Addr;
	ROM_DATA = Data;
	if ( ROM_STATUS & bROM_ADDR_OK ) {                                           // ַЧ
		ROM_CTRL = ROM_CMD_PROG;
		return( ( ROM_STATUS ^ bROM_ADDR_OK ) & 0x7F );                            // ״̬,0x00=success, 0x01=time out(bROM_CMD_TOUT), 0x02=unknown command(bROM_CMD_ERR)
	}
	else return( 0x40 );
}
/*******************************************************************************
* Function Name  : FlashVerify
* Description    : FlashУ
* Input          : Addr    оƬ̵ַַַΪżַ
                   pData   ݣWORDΪ׼
                   len     У鳤
* Output         : None
* Return         :         У״̬
                    0x00   Уɹ
                    0xff   Уʧ
*******************************************************************************/
UINT8 FlashVerify( UINT16 Addr, UINT8 *pData, UINT16 len )
{
    UINT16 i;
    pCode = (PUINT8C)( Addr );
    for( i=0; i!=len; i++ )
    {
        if( *pData != *pCode )
        {
            return 0xff;
        }
        pCode++;
        pData++;
    }
    return 0;
}
/*******************************************************************************
* Function Name  : UART_Send
* Description    : 0ֽڷ
* Input          : dat    ڴ
* Output         : None
* Return         : None
*******************************************************************************/
void UART_Send( UINT8 dat )
{
    TI = 0;
    SBUF = dat;
    while( TI == 0 ) {;}
}
/*******************************************************************************
* Function Name  : UART_Receive
* Description    : 0ֽڽ
* Input          : None
* Output         : None
* Return         : SBUF ڽֽ
*******************************************************************************/
UINT8 UART_Receive( void )
{
    while( RI == 0 ){;}
    RI = 0;
    return SBUF;
}
/*******************************************************************************
* Function Name  : CH55X_Respond
* Description    : IAPʱоƬӦ
* Input          : s ЧӦֽ
* Output         : None
* Return         : SBUF ڽֽ
*******************************************************************************/
void CH55X_Respond( UINT8 s )
{
    if( uart_bit == 2 )                                            // USBʽ
    {
        Ep2Buffer[ MAX_PACKET_SIZE ]   = s;
        Ep2Buffer[ MAX_PACKET_SIZE+1 ] = 0X00;
        UEP2_T_LEN = 2;
        UEP2_CTRL = UEP2_CTRL & ~ MASK_UEP_T_RES | UEP_T_RES_ACK;  // ϴ
    }
    else                                                           //ڷʽ
    {
        UART_Send( s );
        UART_Send( 0x00 );
    }
}
/*******************************************************************************
* Function Name  : CH559_USB_ISPDownload
* Description    : CH559غ
*                
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void CH55X_IAPDownload( void )
{
    UINT8  s;
    UINT16 i;
    UINT16 len,Data;
    UINT32 addr;
    switch( iap_cmd.other.buf[0] )                                  // 
    {
    case CMD_IAP_PROM:                                              // ISP 
        len = iap_cmd.program.len>>1;                               //Ϊ2հֽв
        addr = (iap_cmd.program.addr[0] | (UINT16)iap_cmd.program.addr[1]<<8);
        SAFE_MOD = 0x55;
        SAFE_MOD = 0xAA;
        GLOBAL_CFG |= bCODE_WE | bDATA_WE;                          //дFlash
        for( i=0; i!=len; i++ )
        {
            Data = (iap_cmd.program.buf[2*i] | (UINT16)iap_cmd.program.buf[2*i+1]<<8);
            s = ProgWord( addr,Data );
            addr+=2;
            if( s != 0x00 )
            {
                break;
            }
        }
        SAFE_MOD = 0x55;
        SAFE_MOD = 0xAA;
        GLOBAL_CFG &= ~ ( bCODE_WE | bDATA_WE );
        CH55X_Respond( s );                                         //У
        break;
    case CMD_IAP_ERASE:                                             // ISP 
        SAFE_MOD = 0x55;
        SAFE_MOD = 0xAA;
        GLOBAL_CFG |= bCODE_WE | bDATA_WE;
        addr = (iap_cmd.erase.addr[0] | (UINT16)iap_cmd.erase.addr[1]<<8);
        for( i=0; addr < IAP_CODE_ADDR; i++ )
        {
            s = EraseBlock( addr );
            addr+=1024;
            if( s != 0 )
            {
                break;
            }
        }
        SAFE_MOD = 0x55;
        SAFE_MOD = 0xAA;
        GLOBAL_CFG &= ~ ( bCODE_WE | bDATA_WE );
        CH55X_Respond( s );
        break;
    case CMD_IAP_VERIFY:                                             // ISP У
        addr = (iap_cmd.verify.addr[0] | (UINT16)iap_cmd.verify.addr[1]<<8);
        len = iap_cmd.verify.len>>1;                                 // Ϊ2ֽв
        s = FlashVerify( addr,&(iap_cmd.verify.buf[0]),iap_cmd.verify.len );
        CH55X_Respond( s );
        break;
    case CMD_IAP_END:                                                // ISP 
        SAFE_MOD = 0x55;
        SAFE_MOD = 0xAA;
        GLOBAL_CFG |= bSW_RESET;                                     // λƬ,û 
        break;
    default:
        CH55X_Respond( 0xfe );                                       // δ֪
        break;
    }
}
/*******************************************************************************
* Function Name  : UATR_Handle
* Description    : ڽմ
*                
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void UATR_Handle( void  )
{
    UINT8 dat,i,len,add_value;
    dat = UART_Receive();
    if( dat == Uart_Sync_Head1 )                                     //ʼֽ
    {
        dat = UART_Receive();
        if( dat == Uart_Sync_Head2 )
        {
            iap_cmd.other.buf[0] = UART_Receive();                   //
            add_value = 0;
            add_value+=iap_cmd.other.buf[0];
            len = iap_cmd.other.buf[1] = UART_Receive();             //ݳ
            add_value+=iap_cmd.other.buf[1];
            if( iap_cmd.other.buf[0] == CMD_IAP_PROM  || iap_cmd.other.buf[0] == CMD_IAP_VERIFY )//ΪУҪ2ֽ
            {
                len+=2;
            }
            for( i=0; i!=len; i++ )
            {
                iap_cmd.other.buf[i+2] = UART_Receive();
                add_value+=iap_cmd.other.buf[i+2];
            }
            i = UART_Receive();
            if( add_value != i )
            {
                UART_Send( 0x55 );
                UART_Send( 0xaa );                                   //ۼӺʹҪط
            }
            else
            {
                uart_bit = 1;                                        //ʾ봮
                CH55X_IAPDownload(  );
            }
        }
    }
}
/*******************************************************************************
* Function Name  : USB_DeviceInterrupt
* Description    : USBжϲѯIAP޷ʹж
*                
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void USB_DeviceInterrupt( void )
{
    UINT8    len;
    static    UINT8    SetupReqCode, SetupLen;
    static    PUINT8    pDescr;
    if( UIF_TRANSFER )                                                // USB
    {
        if ( U_IS_NAK ){}                                             // ӿԲشNAK
        else
        {
            switch ( USB_INT_ST & ( MASK_UIS_TOKEN | MASK_UIS_ENDP ) )// ƺͶ˵
            {
            case UIS_TOKEN_OUT | 2:                                   // endpoint 2# ˵´
                if ( U_TOG_OK )                                       // ͬݰ
                {
                    len = USB_RX_LEN;
                    memcpy( iap_cmd.other.buf,Ep2Buffer,len );
                    uart_bit = 2;
                    CH55X_IAPDownload( );
                }
                break;
            case UIS_TOKEN_IN | 2:                                    // endpoint 2# ˵ϴ
                UEP2_CTRL = UEP2_CTRL & ~ MASK_UEP_T_RES | UEP_T_RES_NAK;// ͣϴ
                break;
            case UIS_TOKEN_IN | 1:                                    // endpoint 1# ж϶˵ϴ
                UEP1_CTRL = UEP1_CTRL & ~ MASK_UEP_T_RES | UEP_T_RES_NAK;// ͣϴ
                break;
            case UIS_TOKEN_SETUP | 0:                                 // endpoint 0# SETUP
                len = USB_RX_LEN;
                if ( len == sizeof( USB_SETUP_REQ ) )                 // SETUP
                {
                    SetupLen = UsbSetupBuf->wLengthL;
                    if ( UsbSetupBuf->wLengthH || SetupLen > 0x7F )
                    {
                        SetupLen = 0x7F;                              // ܳ
                    }
                    len = 0;                                          // ĬΪɹϴ0
                    if ( ( UsbSetupBuf->bRequestType & USB_REQ_TYP_MASK ) != USB_REQ_TYP_STANDARD )//ֱֻ֧׼
                    {
                        len = 0xFF;                                   // ʧ
                    }
                    else                                              // ׼
                    {
                        SetupReqCode = UsbSetupBuf->bRequest;
                        switch( SetupReqCode )                        // 
                        {
                        case USB_GET_DESCRIPTOR:
                            switch( UsbSetupBuf->wValueH )
                            {
                            case 1:                                   // 豸
                                pDescr = (PUINT8)( &MyDevDescr[0] );
                                len = sizeof( MyDevDescr );
                                break;
                            case 2:                                   // 
                                pDescr = (PUINT8)( &MyCfgDescr[0] );
                                len = sizeof( MyCfgDescr );
                                break;
                            default:
                                len = 0xFF;                           // ֵ֧
                                break;
                            }
                            if ( SetupLen > len )
                            {
                                SetupLen = len;                       // ܳ
                            }
                            len = SetupLen >= THIS_ENDP0_SIZE ? THIS_ENDP0_SIZE : SetupLen;// δ䳤
                            memcpy( Ep0Buffer, pDescr, len );         // ϴ 
                            SetupLen -= len;
                            pDescr += len;
                            break;
                        case USB_SET_ADDRESS:
                            SetupLen = UsbSetupBuf->wValueL;          // ݴUSB豸ַ
                            break;
                        case USB_GET_CONFIGURATION:
                            Ep0Buffer[0] = UsbConfig;
                            if ( SetupLen >= 1 )
                            {
                                len = 1;
                            }
                            break;
                        case USB_SET_CONFIGURATION:
                            UsbConfig = UsbSetupBuf->wValueL;
                            break;
                        default:
                            len = 0xFF;                               // ʧ
                            break;
                        }
                    }
                }
                else
                {
                    len = 0xFF;                                       // SETUPȴ
                }
                if ( len == 0xFF )                                    // ʧ
                {
                    SetupReqCode = 0xFF;
                    UEP0_CTRL = bUEP_R_TOG | bUEP_T_TOG | UEP_R_RES_STALL | UEP_T_RES_STALL;// STALL
                }
                else if ( len <= THIS_ENDP0_SIZE )                    // ϴݻ״̬׶η0Ȱ
                {
                    UEP0_T_LEN = len;
                    UEP0_CTRL  = bUEP_R_TOG | bUEP_T_TOG | UEP_R_RES_ACK | UEP_T_RES_ACK;// ĬݰDATA1
                }
                else                                                  // ´ݻ
                {
                    UEP0_T_LEN = 0;                                   // Ȼδ״̬׶ΣǰԤϴ0ݰԷǰ״̬׶
                    UEP0_CTRL = bUEP_R_TOG | bUEP_T_TOG | UEP_R_RES_ACK | UEP_T_RES_ACK;// ĬݰDATA1
                }
                break;
            case UIS_TOKEN_IN | 0:                                    // endpoint 0# IN
                switch( SetupReqCode )
                {
                case USB_GET_DESCRIPTOR:
                    len = SetupLen >= THIS_ENDP0_SIZE ? THIS_ENDP0_SIZE : SetupLen;// δ䳤
                    memcpy( Ep0Buffer, pDescr, len );                 // ϴ 
                    SetupLen -= len;
                    pDescr += len;
                    UEP0_T_LEN = len;
                    UEP0_CTRL ^= bUEP_T_TOG;                          // ת
                    break;
                case USB_SET_ADDRESS:
                    USB_DEV_AD = USB_DEV_AD & bUDA_GP_BIT | SetupLen;
                    UEP0_CTRL = UEP_R_RES_ACK | UEP_T_RES_NAK;
                    break;
                default:
                    UEP0_T_LEN = 0;                                   // ״̬׶жϻǿϴ0ݰƴ
                    UEP0_CTRL = UEP_R_RES_ACK | UEP_T_RES_NAK;
                    break;
                }
                break;
            case UIS_TOKEN_OUT | 0:                                   // endpoint 0# OUT
                switch( SetupReqCode )
                {
                default:
                    UEP0_CTRL = UEP_R_RES_ACK | UEP_T_RES_NAK;        // ׼һƴ
                    break;
                }
                break;
            default:
                break;
            }
        }
        UIF_TRANSFER = 0;                                             // жϱ־
    }
    else if ( UIF_BUS_RST )                                           // USB߸λ
    {
        UEP0_CTRL = UEP_R_RES_ACK | UEP_T_RES_NAK;
        UEP1_CTRL = bUEP_AUTO_TOG | UEP_R_RES_ACK;
        UEP2_CTRL = bUEP_AUTO_TOG | UEP_R_RES_ACK | UEP_T_RES_NAK;
        USB_DEV_AD = 0x00;
        UIF_SUSPEND = 0;
        UIF_TRANSFER = 0;
        UIF_BUS_RST = 0;                                              // жϱ־
    }
    else if ( UIF_SUSPEND )                                           // USB߹/
    {
        UIF_SUSPEND = 0;
    }
    else                                                              // ж,ܷ
    {
        USB_INT_FG = 0xFF;                                            // жϱ־
    }
}
/*******************************************************************************
* Function Name  : UART0_Init
* Description    : ڳʼ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void UART0_Init( void )
{
    SCON = 0x50;
    PCON |= SMOD;
    TMOD = TMOD & ~ bT1_GATE & ~ bT1_CT & ~ MASK_T1_MOD | bT1_M1;
    T2MOD = T2MOD | bTMR_CLK | bT1_CLK;
    TH1 = 0-13;                          
    TR1 = 1;
    TI = 0;
    RI = 0;
    P0 = 0;
    PORT_CFG |= bP0_OC;
    P0_DIR |= bTXD_;
    P0_PU |= bTXD_ | bRXD_;
    PIN_FUNC = bUART0_PIN_X;                                            /*ӳ䵽P0.2P0.3*/
    ES = 0;
}
/*******************************************************************************
* Function Name  : USB_DeviceInit
* Description    : USB豸ģʽʼ
*                
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void USB_DeviceInit( void )
{
    IE_USB = 0;
    USB_CTRL = 0x00;                                                   /* 趨ģʽ*/
    UEP2_3_MOD = bUEP2_RX_EN | bUEP2_TX_EN;                            /* ˵2´OUTϴIN */
    UEP0_DMA = Ep0Buffer;
    UEP2_DMA = Ep2Buffer;
    UEP0_CTRL = UEP_R_RES_ACK | UEP_T_RES_NAK;
    UEP2_CTRL = bUEP_AUTO_TOG | UEP_R_RES_ACK | UEP_T_RES_NAK;         /*ͬ־Զת,ACKԼNAK*/
    USB_DEV_AD = 0x00;
    UHUB0_CTRL = bUH_DP_PD_DIS | bUH_DM_PD_DIS;                        /* ֹDP/DM*/
    USB_CTRL = bUC_DEV_PU_EN | bUC_INT_BUSY | bUC_DMA_EN;              /* USB豸DMAжڼжϱ־δǰԶNAK*/
    UHUB0_CTRL |= bUH_PORT_EN;                                         /* USB˿ */
    USB_INT_FG = 0xFF;                                                 /* жϱ־ */
    IE_USB = 0;                                                        /* رUSBж */
}
/*******************************************************************************
* Function Name  : mDelay20us(UNIT16 n)
* Description    : 20usʱƵ12MHzʱ׼ƵοDEBUG.Cʱ
* Input          : UNIT16 n
* Output         : None
* Return         : None
*******************************************************************************/ 
void mDelay20us( UINT16 n )
{
    for( n <<= 3; n; --n )
    {
        _nop_( );
    }
}

/*******************************************************************************
* Function Name  : main
* Description    : 
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void main( void )
{
    UINT16 i=0,j;
	  mInitSTDIO( ); 
    EA = 0;                                                              // رжϣIAPʽ޷ʹж
    uart_bit = 0;
    P4_DIR |= 0x0f;                                                      // P40-P43ʹ
    P4_OUT = 0x0f;
    UART0_Init( );                                                       /* ڳʼѯʽ */
    USB_DeviceInit( );                                                   /* USB豸ģʽʼѯʽ */
    while(1)
    {
        i++;
        j++;
        if( RI )
        {
            UATR_Handle( );                                              // ڽݴ
        }
        if( j > 30 )
        {
            j = 0;
            if( USB_INT_FG )
            {
                USB_DeviceInterrupt( );                                  // ѯusbж,鲻ҪƵѯ
            }
        }
        if( i == 20000 )
        {
            i = 0;
        }
        if( i == 0 )                                                     //ǵָʾ
        {
            P4_OUT =  0x0f;
        }
        if( i == 10000 )
        {
            P4_OUT =  ~(1<<3);                                            //
        }
        mDelay20us(1);                                                    // ʱ
        /* ˳iap */
        if( DisableIAP == 0 )                                             // ѯP10͵ƽʱִλִû
        {
            SAFE_MOD = 0x55;
            SAFE_MOD = 0xAA;
            GLOBAL_CFG |= bSW_RESET;                                      //λƬ,û */
        }
    }
}
