/********************************** (C) COPYRIGHT *******************************
* File Name          : MAIN.C
* Author             : WCH
* Version            : V1.0
* Date               : 2020/07/06
* Description        : updata program
*******************************************************************************/
#include <absacc.h>
#include "CH554.h"
#include "CH559_IAP.H"
#include "usb.h"
#include <string.h>
#include <intrins.h>
#include <stdio.h>

sbit juser            = P1 ^ 4;
sbit DisableIAP            = P1 ^ 0;                   //û
#define IAP_CODE_ADDR        (1024*10)
#define app_flag    (IAP_CODE_ADDR-2)
#define debuge_en 0

#define THIS_ENDP0_SIZE         DEFAULT_ENDP0_SIZE
UINT8X	Ep0Buffer[THIS_ENDP0_SIZE + 2 >= MAX_PACKET_SIZE ? MAX_PACKET_SIZE : THIS_ENDP0_SIZE + 2]; // OUT&IN
UINT8X	Ep3Buffer[2];                                                             // IN
UINT8X	Ep2Buffer[2 * MAX_PACKET_SIZE];

UINT32 pack_cnt = 0;
UINT32 var_pack_cnt = 0;
#define UsbSetupBuf     ((PUSB_SETUP_REQ)Ep0Buffer)
// 豸
UINT8C    MyDevDescr[] = { 0x12, 0x01, 0x10, 0x01,
                           0xFF, 0x80, 0x55, THIS_ENDP0_SIZE,
                           0x48, 0x43, 0x37, 0x55,
                           0x00, 0x01, 0x00, 0x00, 0x01, 0x01
                         };
// 
UINT8C    MyCfgDescr[] = { 0x09, 0x02, 0x20, 0x00, 0x01, 0x01, 0x00, 0x80, 0x32,
                           0x09, 0x04, 0x00, 0x00, 0x02, 0xFF, 0x80, 0x55, 0x00,
                           0x07, 0x05, 0x83, 0x02, 0x40, 0x00, 0x00,
                           0x07, 0x05, 0x02, 0x02, 0x40, 0x00, 0x00
                         };
// 
UINT8C	MyLangDescr[] = { 0x04, 0x03, 0x09, 0x04 };
// Ϣ
UINT8C	MyManuInfo[] = { 0x0E, 0x03, 'w', 0, 'c', 0, 'h', 0, '.', 0, 'c', 0, 'n', 0 };
// ƷϢ
UINT8C	MyProdInfo[] = { 0x0C, 0x03, 'C', 0, 'H', 0, '5', 0, '5', 0, '5', 0 };


UINT8    UsbConfig = 0;                                // USBñ־

iap_cmd1 xdata iap_cmd  _at_ 0x0088;                   //IAP
UINT8   uart_bit;                                      //طʽȫֱ־λ1ʾΪڣ2ʾΪUSB
UINT16  chip_id, eeprom_len;
PUINT8C    pCode;

#define USER_ProgrameStartAddr    (0x70)
typedef void( *pTaskFn)( void );
pTaskFn tasksArr[1];

#pragma  NOAREGS





/*******************************************************************************
CH554ֽڱ̣ҪΪ
*******************************************************************************/
UINT8    EraseBlock( UINT16 Addr )
{
    Addr = 0;
    return(0);
}
/*******************************************************************************
* Function Name  : ProgWord
* Description    : оƬ̺
* Input          : Addr    оƬ̵ַַַΪżַ
                   Data    ݣWORDΪ׼
* Output         : None
* Return         :         оƬ̷״̬
                    0x00   ̳ɹ
                    0x01   ̳ʱ
                    0x02   δ֪󣬱ʧ
*******************************************************************************/
UINT8 ProgWord( UINT16 Addr, UINT16 Data )
{
    ROM_ADDR = Addr;
//	ROM_BUF_MOD = bROM_BUF_BYTE;
    ROM_DATA = Data;

    if ( ROM_STATUS & bROM_ADDR_OK )
    {
        ROM_CTRL = 0x9a;
        return( ( ROM_STATUS ^ bROM_ADDR_OK ) & 0x7F );
    }
    else
        return( 0x40 );
}


/*******************************************************************************
* Function Name  : FlashVerify
* Description    : FlashУ
* Input          : Addr    оƬ̵ַַַΪżַ
                   pData   ݣWORDΪ׼
                   len     У鳤
* Output         : None
* Return         :         У״̬
                    0x00   Уɹ
                    0xff   Уʧ
*******************************************************************************/
UINT8 FlashVerify( UINT16 Addr, UINT8 *pData, UINT16 len )
{
    UINT16 i;
    pCode = (PUINT8C)( Addr );

    for( i = 0; i != len; i++ )
    {
//		printf("i:%02x  ",(UINT16)i);
//		printf("u:%02x  ",(UINT16)*pData);
//		printf("f:%02x\n",(UINT16)*pCode);
        if( *pData != *pCode )
        {
//			for(i=0;i<10;)
//				printf("f:%02x\n",(UINT16)*pCode++);
            return 0xff;
        }

        pCode++;
        pData++;
    }

    return 0;
}
/*******************************************************************************
* Function Name  : UART_Send
* Description    : 0ֽڷ
* Input          : dat    ڴ
* Output         : None
* Return         : None
*******************************************************************************/
void UART_Send( UINT8 dat )
{
    TI = 0;
    SBUF = dat;

    while( TI == 0 ) {;}
}
/*******************************************************************************
* Function Name  : UART_Receive
* Description    : 0ֽڽ
* Input          : None
* Output         : None
* Return         : SBUF ڽֽ
*******************************************************************************/
UINT8 UART_Receive( void )
{
    while( RI == 0 ) {;}

    RI = 0;
    return SBUF;
}
/*******************************************************************************
* Function Name  : CH55X_Respond
* Description    : IAPʱоƬӦ
* Input          : s ЧӦֽ
* Output         : None
* Return         : SBUF ڽֽ
*******************************************************************************/
void CH55X_Respond( UINT8 s )
{
    Ep3Buffer[0] =  s;
    Ep3Buffer[1] =  0;
    UEP3_T_LEN = 2;
    UEP3_CTRL = UEP3_CTRL & (~ MASK_UEP_T_RES) | UEP_T_RES_ACK;// ϴ
}

UINT8 write_complete(UINT8 f)
{
    SAFE_MOD = 0x55;
    SAFE_MOD = 0xAA;
    GLOBAL_CFG |= bCODE_WE | bDATA_WE;

    if(f)
    {
        EraseBlock( 0xd7c0 );
        ProgWord( 0xd7c0, 0xffff );
    }
    else
    {
        EraseBlock( 0xd7c0 );
        EraseBlock( 0xd7c0 );
    }

    SAFE_MOD = 0x55;
    SAFE_MOD = 0xAA;
    GLOBAL_CFG &= ~ ( bCODE_WE | bDATA_WE );

    return(0);
}


/*******************************************************************************
* Function Name  : CH559_USB_ISPDownload
* Description    : CH559غ
*                
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void CH55X_IAPDownload( void )
{
    UINT8  s;
    UINT16 i;
    UINT16 len;
    UINT16 addr, tempdata;


//	printf("cmd:%02x\n",(UINT16)iap_cmd.other.buf[0]);
    switch( iap_cmd.other.buf[0] )                                  // 
    {
        case CMD_IAP_PROM:                                              // ISP 
            len = iap_cmd.program.len;
            addr = (iap_cmd.program.addr[0] | (UINT16)iap_cmd.program.addr[1] << 8);

            if( pack_cnt == 0 )
            {
                //ԲκδΪռַ0x00,0x01,0x02,0x03ܹ4ֽ
				len-=4;
				addr+=4;
				for(i=0;i<len;i++)
					iap_cmd.program.buf[i] = iap_cmd.program.buf[i+4];
            }

            if( 3 < addr < app_flag)
            {
                SAFE_MOD = 0x55;
                SAFE_MOD = 0xAA;
                GLOBAL_CFG |= bCODE_WE | bDATA_WE;                          //дFlash

                for( i = 0; i < len; i += 2 )
                {
                    tempdata = ((UINT16)iap_cmd.program.buf[i + 1] << 8) | iap_cmd.program.buf[i];
                    s = ProgWord( addr, tempdata );
                    addr += 2;

                    if( s != 0x00 )
                    {
                        break;
                    }
                }

                SAFE_MOD = 0x55;
                SAFE_MOD = 0xAA;
                GLOBAL_CFG &= ~ ( bCODE_WE | bDATA_WE );
            }
            else
            {
                s = 0xff;
            }

            CH55X_Respond( s );											 //У
            pack_cnt++;
            break;

        case CMD_IAP_ERASE:				// ISP 
            s = 0;
            SAFE_MOD = 0x55;
            SAFE_MOD = 0xAA;
            GLOBAL_CFG |= bCODE_WE | bDATA_WE;
            ProgWord( app_flag, 0 );
            SAFE_MOD = 0x55;
            SAFE_MOD = 0xAA;
            GLOBAL_CFG &= ~ ( bCODE_WE | bDATA_WE );
            CH55X_Respond( s );
            break;

        case CMD_IAP_VERIFY:                                             // ISP У
            addr = (iap_cmd.verify.addr[0] | (UINT16)iap_cmd.verify.addr[1] << 8);
            len = iap_cmd.verify.len;

            if(var_pack_cnt == 0)
            {	//УԴռַ0x00,0x01,0x02,0x03ܹ4ֽ
				iap_cmd.verify.buf[0]  = *(UINT8C *)0X0000;
				iap_cmd.verify.buf[1]  = *(UINT8C *)0X0001;
				iap_cmd.verify.buf[2]  = *(UINT8C *)0X0002;
				iap_cmd.verify.buf[3]  = *(UINT8C *)0X0003;
            }

//			printf("vaddr:%04x\n",addr);
            if(addr < (app_flag))
                s = FlashVerify( addr, &(iap_cmd.verify.buf[0]), iap_cmd.verify.len );
            else
                s = 0;

            CH55X_Respond( s );
            var_pack_cnt++;
            break;

        case CMD_IAP_END:                                                // ISP 
//        SAFE_MOD = 0x55;
//        SAFE_MOD = 0xAA;
//        GLOBAL_CFG |= bSW_RESET;                                     // λƬ,û
            UEP2_CTRL = (UEP2_CTRL & ~ MASK_UEP_R_RES) | UEP_R_RES_ACK;// ϴ
            break;

        case CMD_IAP_SUCCESS:
            SAFE_MOD = 0x55;
            SAFE_MOD = 0xAA;
            GLOBAL_CFG |= bCODE_WE | bDATA_WE;
            ProgWord( app_flag, 0xffff );		//iapʼַǰ1ֽΪ־
            SAFE_MOD = 0x55;
            SAFE_MOD = 0xAA;
            GLOBAL_CFG &= ~ ( bCODE_WE | bDATA_WE );
            CH55X_Respond( s );
            break;

        default:
//		printf("unsupport\n");
            CH55X_Respond( 0xfe );                                       // δ֪
            break;

    }
}
/*******************************************************************************
* Function Name  : UATR_Handle
* Description    : ڽմ
*                
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void UATR_Handle( void  )
{
    UINT8 dat, i, len, add_value;
    dat = UART_Receive();

    if( dat == Uart_Sync_Head1 )                                     //ʼֽ
    {
        dat = UART_Receive();

        if( dat == Uart_Sync_Head2 )
        {
            iap_cmd.other.buf[0] = UART_Receive();                   //
            add_value = 0;
            add_value += iap_cmd.other.buf[0];
            len = iap_cmd.other.buf[1] = UART_Receive();             //ݳ
            add_value += iap_cmd.other.buf[1];

            if( iap_cmd.other.buf[0] == CMD_IAP_PROM  || iap_cmd.other.buf[0] == CMD_IAP_VERIFY )//ΪУҪ2ֽ
            {
                len += 2;
            }

            for( i = 0; i != len; i++ )
            {
                iap_cmd.other.buf[i + 2] = UART_Receive();
                add_value += iap_cmd.other.buf[i + 2];
            }

            i = UART_Receive();

            if( add_value != i )
            {
                UART_Send( 0x55 );
                UART_Send( 0xaa );                                   //ۼӺʹҪط
            }
            else
            {
                uart_bit = 1;                                        //ʾ봮
                CH55X_IAPDownload(  );
            }
        }
    }
}
/*******************************************************************************
* Function Name  : USB_DeviceInterrupt
* Description    : USBжϲѯIAP޷ʹж
*                
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void USB_DeviceInterrupt( void )
{
    UINT8 len;
    static	PUINT8	pDescr;
    static	UINT8	SetupReqCode, SetupLen;

    if(UIF_TRANSFER)            /*D0ݴ*/
    {
        if ( U_IS_NAK )                                                   // not enable for this example
        {
//			switch ( USB_INT_ST & ( MASK_UIS_TOKEN | MASK_UIS_ENDP ) ) {  // ƺͶ˵
//				case UIS_TOKEN_OUT | 2:                                     // endpoint 2# ˵´
//					break;
//				case UIS_TOKEN_IN | 2:                                      // endpoint 2# ˵ϴ
//					break;
//				case UIS_TOKEN_IN | 1:                                      // endpoint 1# ж϶˵ϴ
//					break;
//				default:
//					break;
//			}
        }
        else
        {
            switch ( USB_INT_ST & ( MASK_UIS_TOKEN | MASK_UIS_ENDP ) )     // ƺͶ˵
            {
                case UIS_TOKEN_OUT | 2:                                      // endpoint 2# ˵´
                    uart_bit = 2;	  //USB

                    if ( U_TOG_OK )     // ͬݰ
                    {
//						UEP2_CTRL ^= bUEP_R_TOG;                               // Զת
                        len = USB_RX_LEN;
                        memcpy( iap_cmd.other.buf, Ep2Buffer, len );
                        uart_bit = 2;


                        UEP2_CTRL = (UEP2_CTRL & ~ MASK_UEP_R_RES) | UEP_R_RES_NAK;// ֹͣϴ
                        CH55X_IAPDownload( );
                    }

                    break;

//				case UIS_TOKEN_IN | 2:                                       // endpoint 2# ˵ϴ
////					UEP2_CTRL ^= bUEP_T_TOG;                                 // Զת
//					UEP2_CTRL = UEP2_CTRL & ~ MASK_UEP_T_RES | UEP_T_RES_NAK;  // ͣϴ
//					break;
                case UIS_TOKEN_IN | 3:                                       // endpoint 1# ж϶˵ϴ
//					UEP1_CTRL ^= bUEP_T_TOG;                                 // Զת
                    UEP3_CTRL = (UEP3_CTRL & ~ MASK_UEP_T_RES) | UEP_T_RES_NAK;  // ͣϴ
                    UEP2_CTRL = (UEP2_CTRL & ~ MASK_UEP_R_RES) | UEP_R_RES_ACK;// ϴ
                    break;

                case UIS_TOKEN_SETUP | 0:                                    // endpoint 0# SETUP
                    len = USB_RX_LEN;

                    if ( len == sizeof( USB_SETUP_REQ ) )                      // SETUP
                    {
                        SetupLen = UsbSetupBuf->wLengthL;

                        if ( UsbSetupBuf->wLengthH || SetupLen > 0x7F ) SetupLen = 0x7F;// ܳ

                        len = 0;                                                 // ĬΪɹϴ0
                        SetupReqCode = UsbSetupBuf->bRequest;

                        if ( ( UsbSetupBuf->bRequestType & USB_REQ_TYP_MASK ) != USB_REQ_TYP_STANDARD )   /* Ǳ׼ */
                        {
                            len = 0xFF;
                        }
                        else                                                     // ׼
                        {
                            switch( SetupReqCode )                                 // 
                            {
                                case USB_GET_DESCRIPTOR:
                                    switch( UsbSetupBuf->wValueH )
                                    {
                                        case 1:                                          // 豸
                                            pDescr = (PUINT8)( &MyDevDescr[0] );
                                            len = sizeof( MyDevDescr );
                                            break;

                                        case 2:                                          // 
                                            pDescr = (PUINT8)( &MyCfgDescr[0] );
                                            len = sizeof( MyCfgDescr );
                                            break;

                                        case 3:                                          // ַ
                                            switch( UsbSetupBuf->wValueL )
                                            {
                                                case 1:
                                                    pDescr = (PUINT8)( &MyManuInfo[0] );
                                                    len = sizeof( MyManuInfo );
                                                    break;

                                                case 2:
                                                    pDescr = (PUINT8)( &MyProdInfo[0] );
                                                    len = sizeof( MyProdInfo );
                                                    break;

                                                case 0:
                                                    pDescr = (PUINT8)( &MyLangDescr[0] );
                                                    len = sizeof( MyLangDescr );
                                                    break;

                                                default:
                                                    len = 0xFF;                               // ֵַ֧
                                                    break;
                                            }

                                            break;

                                        default:
                                            len = 0xFF;                                  // ֵ֧
                                            break;
                                    }

                                    if ( SetupLen > len ) SetupLen = len;            // ܳ

                                    len = SetupLen >= THIS_ENDP0_SIZE ? THIS_ENDP0_SIZE : SetupLen;  // δ䳤
                                    memcpy( Ep0Buffer, pDescr, len );                 /* ϴ */
                                    SetupLen -= len;
                                    pDescr += len;
                                    break;

                                case USB_SET_ADDRESS:
                                    SetupLen = UsbSetupBuf->wValueL;                  // ݴUSB豸ַ
                                    break;

                                case USB_GET_CONFIGURATION:
                                    Ep0Buffer[0] = UsbConfig;

                                    if ( SetupLen >= 1 ) len = 1;

                                    break;

                                case USB_SET_CONFIGURATION:
                                    UsbConfig = UsbSetupBuf->wValueL;
                                    break;

                                case USB_CLEAR_FEATURE:
                                    if ( ( UsbSetupBuf->bRequestType & USB_REQ_RECIP_MASK ) == USB_REQ_RECIP_ENDP )    // ˵
                                    {
                                        switch( UsbSetupBuf->wIndexL )
                                        {
                                            case 0x82:
                                                UEP2_CTRL = UEP2_CTRL & ~ ( bUEP_T_TOG | MASK_UEP_T_RES ) | UEP_T_RES_NAK;
                                                break;

                                            case 0x02:
                                                UEP2_CTRL = UEP2_CTRL & ~ ( bUEP_R_TOG | MASK_UEP_R_RES ) | UEP_R_RES_ACK;
                                                break;

                                            case 0x81:
                                                UEP1_CTRL = UEP1_CTRL & ~ ( bUEP_T_TOG | MASK_UEP_T_RES ) | UEP_T_RES_NAK;
                                                break;

                                            case 0x01:
                                                UEP1_CTRL = UEP1_CTRL & ~ ( bUEP_R_TOG | MASK_UEP_R_RES ) | UEP_R_RES_ACK;
                                                break;

                                            default:
                                                len = 0xFF;                                 // ֵ֧Ķ˵
                                                break;
                                        }
                                    }
                                    else len = 0xFF;                                  // Ƕ˵㲻֧

                                    break;

                                case USB_GET_INTERFACE:
                                    Ep0Buffer[0] = 0x00;

                                    if ( SetupLen >= 1 ) len = 1;

                                    break;

                                case USB_GET_STATUS:
                                    Ep0Buffer[0] = 0x00;
                                    Ep0Buffer[1] = 0x00;

                                    if ( SetupLen >= 2 ) len = 2;
                                    else len = SetupLen;

                                    break;

                                default:
                                    len = 0xFF;                                       // ʧ
//									printf("ErrEp0ReqCode=%02X\n",(UINT16)SetupReqCode);

                                    break;
                            }
                        }
                    }
                    else
                    {
                        len = 0xFF;                                            // SETUPȴ
//						printf("ErrEp0ReqSize\n");

                    }

                    if ( len == 0xFF )                                       // ʧ
                    {
                        SetupReqCode = 0xFF;
                        UEP0_CTRL = bUEP_R_TOG | bUEP_T_TOG | UEP_R_RES_STALL | UEP_T_RES_STALL;  // STALL
                    }
                    else if ( len <= THIS_ENDP0_SIZE )                       // ϴݻ״̬׶η0Ȱ
                    {
                        UEP0_T_LEN = len;
                        UEP0_CTRL = bUEP_R_TOG | bUEP_T_TOG | UEP_R_RES_ACK | UEP_T_RES_ACK;  // ĬݰDATA1
                    }
                    else                                                     // ´ݻ
                    {
                        UEP0_T_LEN = 0;  // Ȼδ״̬׶ΣǰԤϴ0ݰԷǰ״̬׶
                        UEP0_CTRL = bUEP_R_TOG | bUEP_T_TOG | UEP_R_RES_ACK | UEP_T_RES_ACK;  // ĬݰDATA1
                    }

                    break;

                case UIS_TOKEN_IN | 0:                                     // endpoint 0# IN
                    switch( SetupReqCode )
                    {
                        case USB_GET_DESCRIPTOR:
                            len = SetupLen >= THIS_ENDP0_SIZE ? THIS_ENDP0_SIZE : SetupLen;  // δ䳤
                            memcpy( Ep0Buffer, pDescr, len );                    /* ϴ */
                            SetupLen -= len;
                            pDescr += len;
                            UEP0_T_LEN = len;
                            UEP0_CTRL ^= bUEP_T_TOG;                             // ת
                            break;

                        case USB_SET_ADDRESS:
                            USB_DEV_AD = USB_DEV_AD & bUDA_GP_BIT | SetupLen;
                            UEP0_CTRL = UEP_R_RES_ACK | UEP_T_RES_NAK;
                            break;

                        default:
                            UEP0_T_LEN = 0;                                      // ״̬׶жϻǿϴ0ݰƴ
                            UEP0_CTRL = UEP_R_RES_ACK | UEP_T_RES_NAK;
                            break;
                    }

                    break;

                case UIS_TOKEN_OUT | 0:                                    // endpoint 0# OUT
                    switch( SetupReqCode )
                    {
//						case download:
//							if ( U_TOG_OK ) {                                  // ͬݰ
//								UEP0_CTRL ^= bUEP_R_TOG;                         // ת
//								                                                 //ȡ´;
//								//UEP0_CTRL = UEP0_CTRL & bUEP_R_TOG | bUEP_T_TOG | UEP_R_RES_ACK | UEP_T_RES_ACK; // Ԥϴ0ݰDATA1Էǰ״̬׶
//							}
//							break;
                        case USB_GET_DESCRIPTOR:
                        default:
                            if ( U_TOG_OK )                                      // ͬݰ
                            {
//								if ( USB_RX_LEN ) control_status_error;
//								else control_ok;                                 // յ0Ȱʾƶ/ϴOK
                            }

//							else control_status_error;
                            UEP0_CTRL = UEP_R_RES_ACK | UEP_T_RES_NAK;           // ׼һƴ
                            break;
                    }

                    break;

                default:
                    break;
            }
        }

        UIF_TRANSFER = 0;
    }
    else if(UIF_BUS_RST)/*߻¼*/
    {
        UEP0_CTRL = UEP_R_RES_ACK | UEP_T_RES_NAK;
        UEP1_CTRL = bUEP_AUTO_TOG | UEP_R_RES_ACK;
        UEP2_CTRL = bUEP_AUTO_TOG | UEP_R_RES_ACK | UEP_T_RES_NAK;
        USB_DEV_AD = 0x00;
        UIF_SUSPEND = 0;
        UIF_TRANSFER = 0;
        UIF_BUS_RST = 0;
    }
    else if(UIF_SUSPEND) /*߸λ¼*/
    {
        UIF_SUSPEND = 0;

        if ( USB_MIS_ST & bUMS_SUSPEND )                              // 
        {
            #ifdef DE_PRINTF
//			printf( "zz" );                                             // ˯״̬
            #endif

            while ( XBUS_AUX & bUART0_TX );                             // ȴ

            SAFE_MOD = 0x55;
            SAFE_MOD = 0xAA;
            WAKE_CTRL = bWAK_BY_USB | bWAK_RXD0_LO;                     // USBRXD0źʱɱ
            PCON |= PD;                                                 // ˯
            SAFE_MOD = 0x55;
            SAFE_MOD = 0xAA;
            WAKE_CTRL = 0x00;
        }
        else                                                          // 
        {
        }
    }
    else/*ǲҪжϣֱ*/
    {
        USB_INT_FG = 0xFF;
    }
}
/*******************************************************************************
* Function Name  : UART0_Init
* Description    : ڳʼ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void UART0_Init( void )
{
    UINT32 x;
    UINT8 x2;

    SM0 = 0;
    SM1 = 1;
    SM2 = 0;                                                                   //0ʹģʽ1
    //ʹTimer1Ϊʷ
    RCLK = 0;                                                                  //UART0ʱ
    TCLK = 0;                                                                  //UART0ʱ

    PCON |= SMOD;
    x = 10 * FREQ_SYS / UART0_BUAD / 16;                                       //ƵעxֵҪ
    x2 = x % 10;
    x /= 10;

    if ( x2 >= 5 ) x ++;                                                       //

    TMOD = TMOD & ~ bT1_GATE & ~ bT1_CT & ~ MASK_T1_MOD | bT1_M1;              //0X20Timer1Ϊ8λԶضʱ
    T2MOD = T2MOD | bTMR_CLK | bT1_CLK;                                        //Timer1ʱѡ
    TH1 = 0 - x;                                                               //12MHz,buad/12Ϊʵò
    TR1 = 1;                                                                   //ʱ1
    TI = 1;
    REN = 1;

    PIN_FUNC = bUART0_PIN_X;
}
/*******************************************************************************
* Function Name  : USB_DeviceInit
* Description    : USB豸ģʽʼ
*                
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void USB_DeviceInit( void )
{
    IE_USB = 0;
    USB_CTRL = 0x00;                                                // 趨ģʽ

    UEP2_3_MOD = bUEP2_RX_EN | bUEP3_TX_EN;                         // ˵2´OUTϴIN
    UEP0_DMA = Ep0Buffer;
    UEP3_DMA = Ep3Buffer;
    UEP2_DMA = Ep2Buffer;
    UEP0_CTRL = UEP_R_RES_ACK | UEP_T_RES_NAK;
    UEP3_CTRL = bUEP_AUTO_TOG | UEP_R_RES_NAK | UEP_T_RES_NAK;
    UEP2_CTRL = bUEP_AUTO_TOG | UEP_R_RES_ACK | UEP_T_RES_NAK;
    USB_DEV_AD = 0x00;
    UDEV_CTRL = bUD_PD_DIS;                                         // ֹDP/DM
    USB_CTRL = bUC_DEV_PU_EN | bUC_INT_BUSY | bUC_DMA_EN;           // USB豸DMAжڼжϱ־δǰԶNAK
    UDEV_CTRL |= bUD_PORT_EN;                                       // USB˿
    USB_INT_FG = 0xFF;                                              // жϱ־
    USB_INT_EN = bUIE_SUSPEND | bUIE_TRANSFER | bUIE_BUS_RST;
    IE_USB = 1;
}
/*******************************************************************************
* Function Name  : mDelay20us(UNIT16 n)
* Description    : 20usʱƵ12MHzʱ׼ƵοDEBUG.Cʱ
* Input          : UNIT16 n
* Output         : None
* Return         : None
*******************************************************************************/
void mDelay20us( UINT16 n )
{
    for( n <<= 3; n; --n )
    {
        _nop_( );
    }
}



/*******************************************************************************
* Function Name  : main
* Description    : 
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void main( )
{
    UINT16 i = 0;
    UINT16 j = 0;

    CfgFsys( );

//	mInitSTDIO( );
//
//	printf("start\n");

    pCode = (PUINT8C)( app_flag );	//iapʼַǰ1ֽΪ־

    P1_MOD_OC |= (1 << 4);
    P1_DIR_PU |= (1 << 4);

    if(juser != 0)
    {
        if(*pCode)
        {
            tasksArr[0] = (pTaskFn)(USER_ProgrameStartAddr);       //ûַ
            (tasksArr[0])( );
        }
    }

    EA = 0;                                                        /* ڳʼѯʽ */
    USB_DeviceInit( );                                                   /* USB豸ģʽʼѯʽ */

    while(1)
    {
        j++;

        if( j > 30 )
        {
            j = 0;

            if( USB_INT_FG )
            {
                USB_DeviceInterrupt( );                                  // ѯusbж,鲻ҪƵѯ
            }
        }

        mDelay20us(1);
        /* ˳iap */
//        if( DisableIAP == 0 )                                             // ѯP10͵ƽʱִλִû
//        {
//            SAFE_MOD = 0x55;
//            SAFE_MOD = 0xAA;
//            GLOBAL_CFG |= bSW_RESET;                                      //λƬ,û */
//        }
    }
}